/*
CZX
Copyright c 2000-2007 ibis inc. All rights reserved
Tvt@C̃CZX́AzlibCZXƓlƂ܂B
ȉ̐ɏ]ApAvP[V܂߂āA{Tvt@CCӂ̖ړIɎgpARɉςčĔzz邱ƂSĂ̐lɋ܂B
PD{Tvt@C̏oɂāAU̕\ȂƁBIWĩTvt@C̐҂łƎ咣ȂƁB
QD\[XύXꍇ́A𖾎邱ƁBύXTvt@CAIWĩ\tgEFAƂU̕\ȂƁB
RD\[XR[h`ōĔzzꍇA{yщLƐӎ폜AeύX肵ȂƁB

Ɛӎ
ETvt@CɊւT|[g͈؂܂B
ETvt@C̎gpɂ蔭Ȃ鑹⑹QɂāAЂ͈؂̐ӔC𕉂܂B
E\[XR[h̉ϋyьJ͎͂RłBAJAT|[g͊e̐ӔCɂčsĂB
ETvt@C̒쌠ɂāAЂ͂܂B
*/

package sample;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;

/**
 * ACrXT[oƂ̐ڑsNXłB
 * @author ibis
 */
public final class IbisConnect
{
	/** ACrXT[õNGXgURLB */
	public static final String IBIS_REQUEST_URL = "http://ibis.ne.jp/br/request";
	/** ACrXT[oƂ̐ڑ^CAEgB */
	private static final int IBIS_TIMEOUT_CONNECT = 60000;
	/** ACrXT[õ[h^CAEgB */
	private static final int IBIS_TIMEOUT_READ = 60000;
	
	/**
	 * ACrXT[oɑ΂httpNGXgAX|X擾܂B<BR>
	 * sꍇ̓G[܂B
	 * @param res			X|X
	 * @param id			ID
	 * @param requestUrl	URL
	 * @throws IOException
	 */
	public static InputStream connectIbisServer4Regist(String id, String requestUrl) throws IOException, IbisRequestException
	{
		HttpURLConnection conn = null;
		try {
			URL url = new URL(IBIS_REQUEST_URL);
			conn = (HttpURLConnection)url.openConnection();
			// ^CAEg̐ݒ
			conn.setConnectTimeout(IBIS_TIMEOUT_CONNECT);
			conn.setReadTimeout(IBIS_TIMEOUT_READ);
			// NGXg̐ݒ
			String postData = "";
			postData += "mode=1";	// o^ŝŃ[h́uPvŒ
			postData += "&url=" + URLEncoder.encode(requestUrl, "UTF-8");
			postData += "&id=" + id;
			conn.setDoOutput(true);
			conn.setRequestMethod("POST");
			
			conn.connect();
			
			OutputStream out = null;
			out = conn.getOutputStream();
			out.write(postData.getBytes());
			
			int code = conn.getResponseCode();
			if(code < 400) {	// 펞
				// ACrXT[õX|XԂ
				return conn.getInputStream();
			}
			//ُ펞́AG[ԋp
			String message = conn.getResponseMessage();
			throw new IbisRequestException(message);
		} catch (MalformedURLException e) {
			// G[ԋp
			String message = "URLłBURL:" + IBIS_REQUEST_URL;
			throw new IbisRequestException(message);
		}
	}
	
	/**
	 * ACrXT[oƂ̐ڑɔExceptionłB
	 * @author ibis
	 */
	public static class IbisRequestException extends Exception
	{
		private static final long serialVersionUID = -5037369865745063941L;

		IbisRequestException(String message)
		{
			super(message);
		}
	}
}
